"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard").default;
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ContentEntryGuard = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = _interopRequireWildcard(require("react"));
var _hooks = require("../../hooks");
var _Progress = require("@webiny/ui/Progress");
var _LockedRecord = require("../LockedRecord");
var ContentEntryGuard = exports.ContentEntryGuard = function ContentEntryGuard(props) {
  var loading = props.loading,
    entry = props.entry,
    model = props.model,
    children = props.children;
  var _useRecordLocking = (0, _hooks.useRecordLocking)(),
    fetchLockedEntryLockRecord = _useRecordLocking.fetchLockedEntryLockRecord;
  var _useState = (0, _react.useState)(undefined),
    _useState2 = (0, _slicedToArray2.default)(_useState, 2),
    locked = _useState2[0],
    setLocked = _useState2[1];
  (0, _react.useEffect)(function () {
    if (!entry.id || loading || locked !== undefined) {
      return;
    }
    (async function () {
      var result = await fetchLockedEntryLockRecord({
        id: entry.id,
        $lockingType: model.modelId
      });
      setLocked(result);
    })();
  }, [entry.id, loading]);
  if (locked === undefined) {
    return /*#__PURE__*/_react.default.createElement(_Progress.CircularProgress, null);
  } else if (locked) {
    return /*#__PURE__*/_react.default.createElement(_LockedRecord.LockedRecord, {
      record: locked
    });
  }
  return children;
};

//# sourceMappingURL=ContentEntryGuard.js.map