"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UseRecordsDecorator = void 0;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _appAco = require("@webiny/app-aco");
/**
 * When record locking mechanism is checking for records equality, it compares record `id` and `savedOn`.
 * When you're updating ACO cache, you're just passing the new content entry value(s), and sometimes you might
 * be doing it without the `savedOn`, and that causes record locking to keep its old state.
 *
 * This decorator ensures that calls to `updateRecordInCache` always include a `savedOn` timestamp.
 */
var UseRecordsDecorator = exports.UseRecordsDecorator = _appAco.useRecords.createDecorator(function (baseHook) {
  return function (folderId) {
    var hook = baseHook(folderId);
    return (0, _objectSpread2.default)((0, _objectSpread2.default)({}, hook), {}, {
      updateRecordInCache: function updateRecordInCache(record) {
        hook.updateRecordInCache((0, _objectSpread2.default)((0, _objectSpread2.default)({}, record), {}, {
          savedOn: new Date().toISOString()
        }));
      }
    });
  };
});

//# sourceMappingURL=UseRecordsDecorator.js.map