"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RecordLockingPermissions = void 0;
var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _react = _interopRequireWildcard(require("react"));
var _Grid = require("@webiny/ui/Grid");
var _Select = require("@webiny/ui/Select");
var _i18n = require("@webiny/app/i18n");
var _Permissions = require("@webiny/app-admin/components/Permissions");
var _form = require("@webiny/form");
var _templateObject, _templateObject2, _templateObject3, _templateObject4;
var t = _i18n.i18n.ns("app-record-locking/components/permissionRenderer");
var RECORD_LOCKING_PERMISSION = "recordLocking";
var RecordLockingPermissions = exports.RecordLockingPermissions = function RecordLockingPermissions(_ref) {
  var value = _ref.value,
    onChange = _ref.onChange;
  var onFormChange = (0, _react.useCallback)(function (data) {
    var newValue = value.filter(function (p) {
      return p.name.startsWith(RECORD_LOCKING_PERMISSION) === false;
    });
    if (!data.canForceUnlock || data.canForceUnlock === "no") {
      onChange(newValue);
      return;
    }
    onChange([].concat((0, _toConsumableArray2.default)(newValue), [{
      name: "recordLocking",
      canForceUnlock: "yes"
    }]));
  }, [value]);
  var formData = (0, _react.useMemo)(function () {
    if (!Array.isArray(value)) {
      return {};
    }
    var hasFullAccess = value.some(function (item) {
      return item.name === "*";
    });
    if (hasFullAccess) {
      return {
        canForceUnlock: "yes"
      };
    }
    var permissions = value.filter(function (item) {
      return item.name.startsWith(RECORD_LOCKING_PERMISSION);
    });
    if (!permissions.length || !permissions.some(function (item) {
      return !!item.canForceUnlock;
    })) {
      return {};
    }
    return {
      canForceUnlock: "yes"
    };
  }, []);
  return /*#__PURE__*/_react.default.createElement(_form.Form, {
    data: formData,
    onChange: onFormChange
  }, function (_ref2) {
    var Bind = _ref2.Bind;
    return /*#__PURE__*/_react.default.createElement(_react.Fragment, null, /*#__PURE__*/_react.default.createElement(_Grid.Grid, {
      className: _Permissions.gridNoPaddingClass
    }, /*#__PURE__*/_react.default.createElement(_Grid.Cell, {
      span: 6
    }, /*#__PURE__*/_react.default.createElement(_Permissions.PermissionInfo, {
      title: t(_templateObject || (_templateObject = (0, _taggedTemplateLiteral2.default)(["Advanced Record Locking"])))
    })), /*#__PURE__*/_react.default.createElement(_Grid.Cell, {
      span: 6
    }, /*#__PURE__*/_react.default.createElement(Bind, {
      name: "canForceUnlock"
    }, /*#__PURE__*/_react.default.createElement(_Select.Select, {
      label: t(_templateObject2 || (_templateObject2 = (0, _taggedTemplateLiteral2.default)(["Advanced Record Locking"])))
    }, /*#__PURE__*/_react.default.createElement("option", {
      value: ""
    }, t(_templateObject3 || (_templateObject3 = (0, _taggedTemplateLiteral2.default)(["No Access"])))), /*#__PURE__*/_react.default.createElement("option", {
      value: "yes"
    }, t(_templateObject4 || (_templateObject4 = (0, _taggedTemplateLiteral2.default)(["Full Access"])))))))));
  });
};

//# sourceMappingURL=RecordLockingPermissions.js.map