"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  RecordLocking: true
};
exports.RecordLocking = void 0;
var _react = _interopRequireDefault(require("react"));
var _app = require("@webiny/app");
var _RecordLockingProvider = require("./components/RecordLockingProvider");
Object.keys(_RecordLockingProvider).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _RecordLockingProvider[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _RecordLockingProvider[key];
    }
  });
});
var _HeadlessCmsActionsAcoCell = require("./components/HeadlessCmsActionsAcoCell");
var _HeadlessCmsContentEntry = require("./components/HeadlessCmsContentEntry");
var _appWcp = require("@webiny/app-wcp");
var _plugins = require("@webiny/plugins");
var _permissionRenderer = require("./components/permissionRenderer");
var _hooks = require("./hooks");
Object.keys(_hooks).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _hooks[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _hooks[key];
    }
  });
});
var RecordLockingHoc = function RecordLockingHoc(Component) {
  return function RecordLockingProvider(_ref) {
    var children = _ref.children;
    return /*#__PURE__*/_react.default.createElement(Component, null, /*#__PURE__*/_react.default.createElement(_RecordLockingProvider.RecordLockingProvider, null, children));
  };
};
var RecordLocking = exports.RecordLocking = function RecordLocking() {
  var wcp = (0, _appWcp.useWcp)();
  if (!wcp.canUseRecordLocking()) {
    return null;
  }
  _plugins.plugins.register(_permissionRenderer.recordLockingPermissionRenderer);
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_app.Provider, {
    hoc: RecordLockingHoc
  }), /*#__PURE__*/_react.default.createElement(_HeadlessCmsActionsAcoCell.HeadlessCmsActionsAcoCell, null), /*#__PURE__*/_react.default.createElement(_HeadlessCmsContentEntry.HeadlessCmsContentEntry, null));
};

//# sourceMappingURL=index.js.map